<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px" />
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">设施类别</el-col>
    </el-row>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd" v-hasPermi="['basecfg:facscategory:add']">新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['basecfg:facscategory:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['basecfg:facscategory:remove']">删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="typeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="类别代码" align="center" prop="code" />
      <el-table-column label="类别名称" align="center" prop="name" />
      <el-table-column label="说明" align="center" prop="desc" />
      <el-table-column label="数据版本" align="center" prop="version" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text"  icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['basecfg:facscategory:edit']">
            修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" class="deleteBtn" @click="handleDelete(scope.row)" v-hasPermi="['basecfg:facscategory:remove']">
            删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改能源设施/系统分类对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="类别代码" prop="code">
          <el-input v-model="form.code" placeholder="请输入设施类别代码" />
        </el-form-item>
        <el-form-item label="类别名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入设施类别名称" />
        </el-form-item>
        <el-form-item label="说明" prop="desc">
          <el-input v-model="form.desc" placeholder="请输入说明" />
        </el-form-item>
        <el-form-item label="数据版本" prop="version">
          <el-input v-model="form.version" placeholder="请输入数据版本" />
        </el-form-item>
        <el-form-item label="类别细分" prop="subtypeList">
          <el-table class="sub-table" v-loading="loading" :data="form.subtypeList" max-height="280px">
            <el-table-column label="子类别代码" align="center" prop="code">
              <template slot-scope="scope">
                <el-input size="mini" v-model="scope.row.code" placeholder="请输入代码" />
              </template>
            </el-table-column>
            <el-table-column label="子类别名称" align="center" prop="name">
              <template slot-scope="scope">
                <el-input size="mini" v-model="scope.row.name" placeholder="请输入名称" />
              </template>
            </el-table-column>
            <el-table-column align="center">
              <template slot="header">
                <div class="operateBtns" @click="addSub">
                  <span>操作</span><i class="el-icon-circle-plus-outline"></i>
                </div>
              </template>
              <template slot-scope="scope">
                <i class="el-icon-delete" @click="deleteSub(scope.$index)"></i>
              </template>
            </el-table-column>
          </el-table>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listFacsCategory, getFacsCategory, delFacsCategory, addFacsCategory, updateFacsCategory } from '@/api/basecfg/facscategory'

export default {
  name: 'Type',
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 能源设施/系统分类表格数据
      typeList: [],
      // 子类表格数据
      subTypeList: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        code: null,
        name: null,
        desc: null,
        version: null,
        subtypeList: null
      },
      // 表单参数
      form: {
        id: null,
        code: null,
        name: null,
        desc: null,
        version: null,
        subtypeList: []
      },
      // 表单校验
      rules: {
        code: [{ required: true, message: '设施系统代码不能为空', trigger: 'blur' }],
        name: [{ required: true, message: '设施系统名称不能为空', trigger: 'blur' }]
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    addSub() {
      this.form.subtypeList.push({
        name: '',
        code: '',
        parentCode: this.form.code
      })
    },
    deleteSub(index) {
      this.form.subtypeList.splice(index, 1)
    },
    /** 查询能源设施/系统分类列表 */
    getList() {
      this.loading = true
      listFacsCategory(this.queryParams).then(response => {
        this.typeList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = this.$options.data().form
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加能源设施/系统分类'
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const id = row.id || this.ids
      getFacsCategory(id).then(response => {
        this.form = response.data
        this.open = true
        this.title = '修改能源设施/系统分类'
      })
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          this.form.subtypeList = this.form.subtypeList.filter(item => item.name !== '' && item.value !== '')
          if (this.form.id != null) {
            updateFacsCategory(this.form).then(response => {
              this.$modal.msgSuccess('修改成功')
              this.open = false
              this.getList()
            })
          } else {
            addFacsCategory(this.form).then(response => {
              this.$modal.msgSuccess('新增成功')
              this.open = false
              this.getList()
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids
      this.$modal
        .confirm('是否确认删除能源设施/系统分类编号为"' + ids + '"的数据项？')
        .then(function() {
          return delFacsCategory(ids)
        })
        .then(() => {
          this.getList()
          this.$modal.msgSuccess('删除成功')
        })
        .catch(() => {})
    }
  }
}
</script>
<style lang="scss" scoped>
.sub-table {
  .el-icon-delete {
    cursor: pointer;
  }
  .operateBtns {
    cursor: pointer;
    i {
      color: #1990ff;
      margin-left: 5px;
    }
  }
}
</style>
